d(X,X,1).			

d(T,X,0) :- atom(T) ; number(T).

d(U+V,X,DU+DV) :- d(U,X,DU), d(V,X,DV).

d(U-V,X,DU+ (-DV)) :- d(U,X,DU), d(V,X,DV).

d(-T,X,-R) :- d(T,X,R).

d(K*U,X,K*W) :- number(K), d(U,X,W).

d(U*V,X,B*U+A*V) :- d(U,X,A), d(V,X,B).

d(U/V,X,W) :- d(U*V^ (-1),X,W).

d(U^V,X,V*W*U^ (V+ (-1))) :- number(V), d(U,X,W).

d(U^V,X,Z*log(U)*U^V+V*W*U^ (V+ (-1))) :- d(U,X,W), d(V,X,Z).

d(log(T),X,R*T^ (-1)) :- d(T,X,R).

d(exp(T),X,R*exp(T)) :- d(T,X,R).

d(sin(T),X,R*cos(T)) :- d(T,X,R).

d(cos(T),X,-R*sin(T)) :- d(T,X,R).

d(tan(T),X,W) :- d(sin(T)/cos(T),X,W).


simplify(X,X) :- atomic(X),!.
simplify(X,Y) :- X =..[Op,Z],simplify(Z,Z1), rewrite(Op,Z1,Y).
simplify(X,Y) :- X=..[Op,Z,W],simplify(Z,Z1),
		simplify(W,W1),
		rewrite(Op,Z1,W1,Y).

rewrite(exp,K*log(X),W):- binary(^,X,K,W).
rewrite(-,A+B,C+D):- unary(-,A,C), unary(-,B,D).
rewrite(X,Y,Z):- unary(X,Y,Z).

rewrite(*,X,X,W):-binary(^,X,2,W).
rewrite(*,-X,-Y,Z):- binary(*,X,Y,Z).
rewrite(*,-X,X,W):- binary(^,X,2,Z),unary(-,Z,W).
rewrite(*,X,-X,W):-binary(^,X,2,Z),unary(-,Z,W).
rewrite(*,X,-Y,W):- binary(*,X,Y,Z), unary(-,Z,W).
rewrite(*,-X,Y,W):- binary(*,X,Y,Z), unary(-,Z,W).
rewrite(*,A^X,A^Y,W):- binary(+,X,Y,Z), binary(^,A,Z,W).
rewrite(*,X^A,Y^A,W):- binary(*,X,Y,Z), binary(^,Z,A,W).
rewrite(^,X*Y^ (-1),-Z,W):- binary(^,Y*X^ (-1),Z,W).
rewrite(X,Y,Z,W):- binary(X,Y,Z,W).

unary(-,-X,X).
unary(-,0,0).
unary(-,X,Y):- number(X),Y is -X.
unary(log,1,0).			unary(log,exp(X),X).
unary(exp,0,1).			unary(exp,log(X),X).
unary(sin,0,0).			unary(sin,-X,- sin(X)).
unary(cos,0,1).			unary(cos,-X,cos(X)).

unary(Op,X,Y):- Y =..[Op,X].

binary(+,X,0,X).		binary(+,0,X,X).
binary(+,X,-X,0).		binary(+,-X,X,0).
binary(+,(sin(X))^2,(cos(X))^2,1).
binary(+,(cos(X))^2,(sin(X))^2,1).
binary(+,X,Y,Z):- number(X),number(Y),Z is X+Y.
binary(+,A,B,B+A):- number(B).
binary(+,A,B,A+B).	%%nemusi byt, zajistime dole

binary(*,X,1,X).		binary(*,1,X,X).
binary(*,0,_,0).		binary(*,_,0,0).
binary(*,-1,X,-X).		binary(*,X,-1,-X).
binary(*,X,X^ (-1),1).		binary(*,X^ (-1),X,1).
binary(*,X,Y,Z):- number(X),number(Y),Z is X*Y.
binary(*,A,B,B*A):- number(B).

binary(^,1,_,1).
binary(^,X,1,X).
binary(^,_,0,1).

binary(/, X, X, 1).
binary(/, X, 1, X).
binary(/, 1, X, X^ (-1)).
binary(/,sin(X),cos(X),tan(X)).
binary(/, X, Y, Z) :- number(X),number(Y),Z is float(X)/Y.

binary(Op,X,Y,Z):- Z =..[Op,X,Y].


%%%:-op(100,fx,sin).
%%%:-op(100,fx,cos).

go(X,Y,Z):-d(X,Y,U),simplify(U,Z).
